# Coriolis Core (CRL) Documentation

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Static Public Member Functions | List of all members
CRL::CatalogExtension Class Reference

Wrapper to access a Hurricane::Cell Catalog::State. More...

## Static Public Member Functions
static bool | isFeed (const Cell *)
static bool | isPad (const Cell *)
static bool | isGds (const Cell *)
static bool | isDelete (const Cell *)
static bool | isPhysical (const Cell *)
static bool | isLogical (const Cell *)
static unsigned int | getFlags (const Cell *, unsigned int mask=(unsigned int)-1)
static bool | setFlags (const Cell *, unsigned int mask, bool value)
static bool | setFeed (const Cell *, bool value)
static bool | setPad (const Cell *, bool value)
static bool | setGds (const Cell *, bool value)
static bool | setDelete (const Cell *, bool value)
static bool | setPhysical (const Cell *, bool value)
static bool | setLogical (const Cell *, bool value)
static Library * | getLibrary (const Cell *)
static unsigned int | getDepth (const Cell *)
static Library * | setLibrary (const Cell *, Library *library)

## Detailed Description

Wrapper to access a Hurricane::Cell Catalog::State.

Catalog::State are stored inside the AllianceFramework Catalog but also linked in a Property on the Hurricane::Cell for easier access. The CatalogExtension is a small wrapper around the Property mechanism to allow a simpler access.

## Member Function Documentation

bool CRL::CatalogExtension::isFeed | ( | const Cell * | cell | ) |
| inline static

Returns: true if the Cell is a feed-through.

References CRL::Catalog::State::isFeed().

bool CRL::CatalogExtension::isPad | ( | const Cell * | cell | ) |
| inline static

Returns: true if the Cell is a pad.

References CRL::Catalog::State::isPad().

bool CRL::CatalogExtension::isGds | ( | const Cell * | cell | ) |
| inline static

Returns: true if the Cell is drawn in real layer (i.e. not a symbolic layout, but a GDS).

References CRL::Catalog::State::isGds().

bool CRL::CatalogExtension::isDelete | ( | const Cell * | cell | ) |
| inline static

Returns: true if the Cell has been deleted from memory.

References CRL::Catalog::State::isDelete().

bool CRL::CatalogExtension::isPhysical | ( | const Cell * | cell | ) |
| inline static

Returns: true if the Cell posseses a physical view (layout).

References CRL::Catalog::State::isPhysical().

bool CRL::CatalogExtension::isLogical | ( | const Cell * | cell | ) |
| inline static

Returns: true if the Cell posseses a logical view (netlist).

References CRL::Catalog::State::isLogical().

unsigned int CRL::CatalogExtension::getFlags | ( | const Cell * | cell,
|  | unsigned int | mask = `(unsigned int)-1`
| ) |  |
| inline static

Returns: the requested flags states (selected by `mask`, all of them by default).

References CRL::Catalog::State::getFlags().

bool CRL::CatalogExtension::setFlags | ( | const Cell * | cell,
|  | unsigned int | mask,
|  | bool | value
| ) |  |
| inline static

Returns: true if at least one flag of the indicated by mask is set. (dubious usefulness).

`mask` is used to designate the bits of the flags on which we are going to operate. If `value` is true, then the bits are sets and if `value` is false they are reset.

References CRL::Catalog::State::setFlags().

bool CRL::CatalogExtension::setFeed | ( | const Cell * | cell,
|  | bool | value
| ) |  |
| inline static

Sets the Feed flag to `value`. Returns true if it is set.

References CRL::Catalog::State::setFeed().

bool CRL::CatalogExtension::setPad | ( | const Cell * | cell,
|  | bool | value
| ) |  |
| inline static

Sets the Pad flag to `value`. Returns true if it is set.

References CRL::Catalog::State::setPad().

bool CRL::CatalogExtension::setGds | ( | const Cell * | cell,
|  | bool | value
| ) |  |
| inline static

Sets the Gds flag to `value`. Returns true if it is set.

References CRL::Catalog::State::setGds().

bool CRL::CatalogExtension::setDelete | ( | const Cell * | cell,
|  | bool | value
| ) |  |
| inline static

Sets the Delete flag to `value`. Returns true if it is set.

References CRL::Catalog::State::setDelete().

bool CRL::CatalogExtension::setPhysical | ( | const Cell * | cell,
|  | bool | value
| ) |  |
| inline static

Sets the Physical flag to `value`. Returns true if it is set.

References CRL::Catalog::State::setPhysical().

bool CRL::CatalogExtension::setLogical | ( | const Cell * | cell,
|  | bool | value
| ) |  |
| inline static

Sets the Logical flag to `value`. Returns true if it is set.

References CRL::Catalog::State::setLogical().

Hurricane::Library * CRL::CatalogExtension::getLibrary | ( | const Cell * | cell | ) |
| inline static

Returns: the associated Hurricane::Library.

References CRL::Catalog::State::getLibrary().

unsigned int CRL::CatalogExtension::getDepth | ( | const Cell * | cell | ) |
| inline static

Returns: the hierarchical depth of the Cell.

References CRL::Catalog::State::getDepth().

Hurricane::Library * CRL::CatalogExtension::setLibrary | ( | const Cell * | cell,
|  | Hurricane::Library * | library
| ) |  |
| inline static

Sets the Library field. Returns the newly affected Library.

References CRL::Catalog::State::setLibrary().

The documentation for this class was generated from the following files:

- Catalog.h
- Catalog.dox

Generated by doxygen 1.8.5 on Thu Mar 19 2020 | Return to top of page

Coriolis Core (CRL) | Copyright © 2008-2016 UPMC All rights reserved